local collect_button_state = false
local collect_researched
local check_level = 0
------------------------------------------ event script

script.on_event(defines.events.on_gui_click, function(event)
	if event.element.name == "get_items" then
		expand_button(game.players[event.player_index])
	end
end)

script.on_event(defines.events.on_gui_checked_state_changed, function(event)
	if event.element.name == "get_items_checkbox" then
		checkbox_button(game.players[event.player_index])
	end
end)

script.on_event(defines.events.on_research_finished, function(event)
	if event.research.name == "automated-construction" then
		collect_researched = true
		-- for player_index = 1, #game.players do
			-- create_button(game.players[player_index])
		-- end
	end
end)

script.on_event(defines.events.on_tick, function(event)
	if event.tick%300 == 0 then
	
		if collect_researched == nil then
			for _,player in pairs(game.players) do
				if player.gui.top.get_items == nil then
					create_button(player)
				end
			end
			collect_researched = false
		end
		
		if not collect_researched and game.players[1].force.technologies["automated-construction"].researched then
			collect_researched = true
		end
		
		-- if collect_researched then writeDebug("T") else writeDebug("F") end
	end
	
	if event.tick%20 == 0 then
		-- writeDebug("tick = " .. event.tick)
		if global.Roboport_Table ~= nil then
			for _,entity in pairs(global.Roboport_Table) do
				if not entity.valid then
					table.remove(global.Roboport_Table, _)
				end
				if #global.Roboport_Table == 0 then
					global.Roboport_Table = nil
				end
				-- writeDebug("remove roboport" .. #global.Roboport_Table)
			end
		end
		
		if collect_researched and collect_button_state then
			if global.Roboport_Table ~= nil then
				local numb = 3
				local top = #global.Roboport_Table - (numb * check_level)
				local bottom = #global.Roboport_Table - numb - (numb * check_level)
				-- writeDebug(top .. " / " .. bottom .. " / " .. check_level)
				check_level = check_level + 1
				for i = top, bottom, -1 do
					if i <= 0 then
						check_level = 0
						break
					end
					scan_item(global.Roboport_Table[i])
				end
			
			end
		end
	end
end)

script.on_event({defines.events.on_built_entity,}, function(event) On_Built(event) end)
script.on_event({defines.events.on_robot_built_entity,}, function(event) On_Built(event) end)


------------------------------------------ scan function

function On_Built(event)
	if event.created_entity.type == "roboport" then
		if global.Roboport_Table == nil then
			global.Roboport_Table = {}
		end
		local radius = event.created_entity.logistic_cell.construction_radius
		if radius >= 10 then
			table.insert(global.Roboport_Table, event.created_entity)
		end
		-- writeDebug("add roboport")
	end
end

function scan_item(entity)
	if entity ~= nil then
		local force = entity.force
		local radius = entity.logistic_cell.construction_radius
		local items = entity.surface.find_entities_filtered{area = {{entity.position.x-radius, entity.position.y-radius}, {entity.position.x+radius, entity.position.y+radius}}, name = "item-on-ground"}
		for _, item in ipairs(items) do
			if not item.to_be_deconstructed(force) then 
				item.order_deconstruction(force)
				-- writeDebug("scan items")
			end
		end
	end
end

------------------------------------------ button

function create_button(target_player)
	local player = target_player.gui.top
	
	if player.get_items == nil then
		player.add{type="button", name="get_items", style="collect_button_style"}
	end
end

function expand_button(player)
	local frame = player.gui.left["collect_button"]
	
	if frame then
		frame.destroy()
	else
		if collect_researched then
			frame = player.gui.left.add{type="frame", name="collect_button"}
			frame.add{type = "checkbox", name = "get_items_checkbox", state = collect_button_state, caption = "Use item collection using robots."}
		else
			frame = player.gui.left.add{type="frame", name="collect_button"}
			frame.add{type = "label", name = "get_items_labelbox", caption = "To use this, Need to develop [Automated construction] technology."}
		end
	end
end

function checkbox_button(player)
	local frame = player.gui.left["collect_button"]
	
	collect_button_state = frame.get_items_checkbox.state
	
end

------------------------------------------ bundle

function writeDebug(message)
	for i, player in pairs(game.players) do
		player.print(tostring(message))
	end
end